'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Community = function () {
  _createClass(Community, null, [{
    key: 'createByCommunityData',
    value: function createByCommunityData(htmlData) {
      return new this({
        title: htmlData.find('.communityData > .title').text().trim(),
        level: ~~htmlData.find('.communityScale > .content').first().text().trim(),
        thumbnailUrl: htmlData.find('.communityThumbnail').find('img').attr('src')
      });
    }
  }, {
    key: 'createByChannelData',
    value: function createByChannelData(htmlData) {
      return new this({
        title: htmlData.find('#head_cp_breadcrumb').find('h1 > a').text().trim(),
        thumbnailUrl: htmlData.find('#cp_symbol').find('img').attr('data-original')
      });
    }
  }, {
    key: 'COMMUNITY_LEVEL_STAND_ROOM_COUNT_TABLE',
    get: function get() {
      return [[0, 49, 1], [50, 69, 2], [70, 104, 3], [105, 149, 4], [150, 189, 5], [190, 229, 6], [230, 255, 7], [256, 999, 9]];
    }
  }]);

  function Community(_ref) {
    var communityId = _ref.communityId,
        title = _ref.title,
        level = _ref.level,
        thumbnailUrl = _ref.thumbnailUrl;

    _classCallCheck(this, Community);

    this.communityId = communityId;
    this.title = title;
    this.level = level;
    this.thumbnailUrl = thumbnailUrl;
  }

  _createClass(Community, [{
    key: 'isChannel',
    value: function isChannel() {
      return (/ch\d+/.test(this.communityId)
      );
    }
  }, {
    key: 'standRoomCount',
    value: function standRoomCount() {
      var _this = this;

      return Community.COMMUNITY_LEVEL_STAND_ROOM_COUNT_TABLE.find(function (el) {
        return el[0] <= _this.level && el[1] >= _this.level;
      })[2];
    }
  }]);

  return Community;
}();

exports.default = Community;