'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _cheerio = require('cheerio');

var _cheerio2 = _interopRequireDefault(_cheerio);

var _BaseConnection2 = require('./BaseConnection');

var _BaseConnection3 = _interopRequireDefault(_BaseConnection2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var AlertConnection = function (_BaseConnection) {
  _inherits(AlertConnection, _BaseConnection);

  function AlertConnection(_ref) {
    var port = _ref.port,
        addr = _ref.addr,
        thread = _ref.thread,
        communityIds = _ref.communityIds;

    _classCallCheck(this, AlertConnection);

    var _this = _possibleConstructorReturn(this, (AlertConnection.__proto__ || Object.getPrototypeOf(AlertConnection)).call(this, {
      port: port,
      addr: addr,
      thread: thread,
      version: '20061206',
      res_from: '-1'
    }));

    _this.followedCommunityIds = communityIds;
    return _this;
  }

  _createClass(AlertConnection, [{
    key: 'setOnDataEvent',
    value: function setOnDataEvent() {
      var _this2 = this;

      this.connection.on('data', function (buffer) {
        var data = (0, _cheerio2.default)('<data>' + buffer + '</data>');
        var resultCode = data.find('thread').attr('resultcode');

        if (resultCode === '0') _this2.connection.emit('handshaked');

        var comments = data.find('chat');
        for (var i = 0, len = comments.length; i < len; i++) {
          var element = (0, _cheerio2.default)(comments[i]);
          var text = element.text();
          if (_this2.isFollowed(text.split(',')[1])) {
            var comment = {
              attr: element.attr(),
              text: text
            };
            _this2.connection.emit('notify', comment);
          }
        }
      });
    }
  }, {
    key: 'isFollowed',
    value: function isFollowed(communityId) {
      return this.followedCommunityIds.indexOf(communityId) !== -1;
    }
  }]);

  return AlertConnection;
}(_BaseConnection3.default);

exports.default = AlertConnection;