'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _cheerio = require('cheerio');

var _cheerio2 = _interopRequireDefault(_cheerio);

var _querystring = require('querystring');

var _querystring2 = _interopRequireDefault(_querystring);

var _request = require('request');

var _request2 = _interopRequireDefault(_request);

var _BaseConnection2 = require('./BaseConnection');

var _BaseConnection3 = _interopRequireDefault(_BaseConnection2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var LiveConnection = function (_BaseConnection) {
  _inherits(LiveConnection, _BaseConnection);

  function LiveConnection(_ref) {
    var port = _ref.port,
        addr = _ref.addr,
        open_time = _ref.open_time,
        thread = _ref.thread,
        version = _ref.version,
        res_from = _ref.res_from,
        user_id = _ref.user_id,
        premium = _ref.premium,
        mail = _ref.mail,
        cookie = _ref.cookie;

    _classCallCheck(this, LiveConnection);

    var _this = _possibleConstructorReturn(this, (LiveConnection.__proto__ || Object.getPrototypeOf(LiveConnection)).call(this, {
      port: port,
      addr: addr,
      thread: thread,
      version: version,
      res_from: res_from
    }));

    _this.open_time = open_time;
    _this.user_id = user_id;
    _this.premium = premium;
    _this.mail = mail;
    _this.cookie = cookie;
    return _this;
  }

  _createClass(LiveConnection, [{
    key: 'setOnDataEvent',
    value: function setOnDataEvent() {
      var _this2 = this;

      this.connection.on('data', function (buffer) {
        var chunk = buffer.toString();
        if (!chunk.match(/\0$/)) return;
        var data = (0, _cheerio2.default)('<data>' + chunk + '</data>');

        var resultCodeValue = data.find('thread').attr('resultcode');
        if (resultCodeValue) {
          var foundThread = data.find('thread');
          _this2.ticket = foundThread.attr('ticket');
          _this2.last_res = foundThread.attr('last_res');
          if (resultCodeValue === '0') {
            _this2.connection.emit('handshaked');
          } else {
            _this2.connection.emit('error', foundThread.toString());
          }
        }

        var comments = data.find('chat');
        for (var i = 0, len = comments.length; i < len; i++) {
          var element = (0, _cheerio2.default)(comments[i]);
          var comment = {
            attr: element.attr(),
            text: element.text(),
            usericon: 'http://uni.res.nimg.jp/img/user/thumb/blank.jpg'
          };
          var _comment$attr = comment.attr,
              anonymity = _comment$attr.anonymity,
              user_id = _comment$attr.user_id;

          if (!anonymity && user_id) comment.usericon = 'http://usericon.nimg.jp/usericon/' + user_id.slice(0, 2) + '/' + user_id + '.jpg';
          _this2.connection.emit('comment', comment);
          _this2.last_res = comment.attr.no;
        }
      });
    }
  }, {
    key: 'comment',
    value: function comment(text) {
      var _this3 = this;

      var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

      this.getPostKey().then(function (postkey) {
        var vpos = (Math.floor(Date.now() / 1000) - _this3.open_time) * 100;
        var chat = (0, _cheerio2.default)('<chat />');
        chat.attr(JSON.parse(JSON.stringify({
          thread: _this3.thread,
          ticket: _this3.ticket,
          mail: _this3.mail,
          user_id: _this3.user_id,
          premium: _this3.premium
        })));
        chat.attr({ vpos: vpos });
        chat.attr({ postkey: postkey });
        if (options.mail) chat.attr('mail', options.mail);
        chat.text(text);
        console.log(chat);

        _this3.connection.write(chat + '\0');
      });
    }
  }, {
    key: 'getPostKey',
    value: function getPostKey() {
      var _this4 = this;

      return new Promise(function (resolve, reject) {
        var query = _querystring2.default.stringify({
          thread: _this4.thread,
          block_no: Math.floor((parseInt(_this4.last_res) + 1) / 100)
        });
        (0, _request2.default)({
          url: 'http://live.nicovideo.jp/api/getpostkey?' + query,
          headers: {
            Cookie: _this4.cookie
          }
        }, function (err, res, body) {
          if (err) reject(err);

          resolve(body.split('=').pop());
        });
      });
    }
  }]);

  return LiveConnection;
}(_BaseConnection3.default);

exports.default = LiveConnection;