'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (liveId, cookie) {
  return new Promise(function (resolve, reject) {
    (0, _request2.default)({
      url: 'http://live.nicovideo.jp/api/getplayerstatus/' + liveId,
      headers: {
        Cookie: cookie
      }
    }, function (err, res, body) {
      if (err) reject(err);

      var playerStatus = (0, _cheerio2.default)(body);

      var errMessage = playerStatus.find('error code').text();
      if (errMessage.length) reject(errMessage);

      var ms = playerStatus.find('ms');
      resolve({
        port: ms.find('port').eq(0).text(),
        addr: ms.find('addr').eq(0).text(),
        open_time: playerStatus.find('open_time').eq(0).text(),
        title: playerStatus.find('title').eq(0).text(),
        description: playerStatus.find('description').eq(0).text(),
        thread: ms.find('thread').eq(0).text(),
        version: '20061206',
        res_from: 0,
        user_id: playerStatus.find('user_id').eq(0).text(),
        premium: playerStatus.find('is_premium').eq(0).text(),
        mail: '184'
      });
    });
  });
};

var _request = require('request');

var _request2 = _interopRequireDefault(_request);

var _cheerio = require('cheerio');

var _cheerio2 = _interopRequireDefault(_cheerio);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }