'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = login;

var _request = require('request');

var _request2 = _interopRequireDefault(_request);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function login(email, password) {
  return new Promise(function (resolve, reject) {
    _request2.default.post({
      url: 'https://secure.nicovideo.jp/secure/login',
      form: {
        mail_tel: email,
        password: password
      }
    }, function (err, res) {
      if (err) reject(err);

      var cookies = res.headers['set-cookie'];
      var cookie = cookies.find(function (cookie) {
        return cookie.indexOf('user_session=user_session') === 0;
      }) || '';
      var userSession = cookie.slice(0, cookie.indexOf(';') + 1);
      if (!userSession) reject('Invalid user');
      resolve(userSession);
    });
  });
}