'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _cheerio = require('cheerio');

var _cheerio2 = _interopRequireDefault(_cheerio);

var _BaseViewer2 = require('./BaseViewer');

var _BaseViewer3 = _interopRequireDefault(_BaseViewer2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var AlertViewer = function (_BaseViewer) {
  _inherits(AlertViewer, _BaseViewer);

  function AlertViewer(_ref) {
    var port = _ref.port,
        addr = _ref.addr,
        thread = _ref.thread,
        communityIds = _ref.communityIds,
        cookie = _ref.cookie;

    _classCallCheck(this, AlertViewer);

    var _this = _possibleConstructorReturn(this, (AlertViewer.__proto__ || Object.getPrototypeOf(AlertViewer)).call(this, {
      port: port,
      addr: addr,
      thread: thread,
      version: '20061206',
      res_from: '-1',
      cookie: cookie
    }));

    _this.followedCommunityIds = communityIds;
    return _this;
  }

  _createClass(AlertViewer, [{
    key: 'setOnDataEvent',
    value: function setOnDataEvent() {
      var _this2 = this;

      this.connection.on('data', function (buffer) {
        var data = (0, _cheerio2.default)('<data>' + buffer + '</data>');
        var resultCode = data.find('thread').attr('resultcode');

        if (resultCode === '0') _this2.connection.emit('handshaked');

        var comments = data.find('chat');
        for (var i = 0, len = comments.length; i < len; i++) {
          var element = (0, _cheerio2.default)(comments[i]);
          var text = element.text();

          var _text$split = text.split(','),
              _text$split2 = _slicedToArray(_text$split, 2),
              liveId = _text$split2[0],
              communityId = _text$split2[1];

          if (_this2.isFollowed(communityId)) {
            _this2.client.getStreamInfo(liveId).then(function (streamInfo) {
              return _this2.connection.emit('notify', streamInfo);
            }).catch(function (err) {
              return _this2.connection.emit('error', err);
            });
          }
        }
      });
    }
  }, {
    key: 'isFollowed',
    value: function isFollowed(communityId) {
      return this.followedCommunityIds.indexOf(communityId) !== -1;
    }
  }]);

  return AlertViewer;
}(_BaseViewer3.default);

exports.default = AlertViewer;